package com.its.api.its.service.vms;

import com.its.api.its.model.dto.vms.TbVmsLinkIfscDto;
import com.its.api.its.model.entity.vms.TbVmsLinkIfsc;
import com.its.api.its.model.entity.vms.TbVmsLinkIfscKey;
import com.its.api.its.repository.vms.TbVmsLinkIfscRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsLinkIfscService {

    private final TbVmsLinkIfscRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVmsLinkIfsc requireOne(TbVmsLinkIfscKey id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    public List<TbVmsLinkIfscDto> findAll() {
        List<TbVmsLinkIfscDto> result = new ArrayList<>();
        List<TbVmsLinkIfsc> data = this.repo.findAll();
        for (TbVmsLinkIfsc entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    public TbVmsLinkIfscDto findById(TbVmsLinkIfscKey id) {
        TbVmsLinkIfsc entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    public TbVmsLinkIfscDto updateById(TbVmsLinkIfscKey id, TbVmsLinkIfscDto.TbVmsLinkIfscUpdReq req) {
        TbVmsLinkIfsc entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public List<TbVmsLinkIfscDto> mergeInfoList(List<TbVmsLinkIfscDto.TbVmsLinkIfscUpdReq> reqList) {
        List<TbVmsLinkIfscDto> result = new ArrayList<>();
        for (TbVmsLinkIfscDto.TbVmsLinkIfscUpdReq req : reqList) {
            TbVmsLinkIfsc obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public TbVmsLinkIfscDto mergeInfo(TbVmsLinkIfscDto.TbVmsLinkIfscUpdReq req) {
        TbVmsLinkIfsc obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    public TbVmsLinkIfscDto deleteById(TbVmsLinkIfscKey id) {
        TbVmsLinkIfsc entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    public List<TbVmsLinkIfscDto> deleteByIds(List<TbVmsLinkIfscKey> ids) {
        List<TbVmsLinkIfscDto> result = new ArrayList<>();
        for (TbVmsLinkIfscKey id : ids) {
            Optional<TbVmsLinkIfsc> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    // VMS_IFSC_ID 사용 중인 갯수 리턴
    public int findUsageCountByVmsIfscId(Long vmsIfscId ) {
        return this.repo.findUsageCountByVmsIfscId(vmsIfscId);
    }

    public List<TbVmsLinkIfscDto> findDataById(Long id) {
        List<TbVmsLinkIfscDto> result = new ArrayList<>();
        List<TbVmsLinkIfsc> list = this.repo.findDataById(id);
        for (TbVmsLinkIfsc obj : list) {
            if (obj.getIfsc() != null && ("N").equals(obj.getIfsc().getDelYn())) {
                // 삭제 된것 제외
                TbVmsLinkIfscDto dto = obj.toDto();
                dto.setIfscInfo(obj.getIfsc()); // 정보제공구간 정보 설정
                result.add(dto);
            }
        }
        return result;
    }

    public void deleteDataById(Long id) {
        this.repo.deleteDataById(id);
    }
}
